<?php
namespace Home\Model;

class UserModel extends BaseModel
{

    //获取用户信息
    function userInfo($uid)
    {
        $result = Array();
        
        //获取用户信息
       // $tmp_arr = array("uid","user_name","user_nickname","user_avatar","sex","gold");
        // $userInfo = get_uinfo_by_uid($userid,$tmp_arr);
        $userInfo = M("game_member","",$this->__lewan_hezi)->where(array('uid'=>$uid))->field('uid,user_nickname as nickName,user_avatar as avatarUrl,sex as gender,gold')->find();

        //获取用户签到信息
        // $sql = "select * from ".get_table("game_member_sign")." where uid=$userid and game_code='hezi' and add_time < '".strtotime(date('Y-m-d'))."' and add_time > '".strtotime(date('Y-m-d',time()-(60*60*24)))."' order by add_time desc";
        // $result = $GLOBALS["conn"]->Query($sql);
        // $signInfo = $GLOBALS["conn"]->getOne($result);
        $sql = "select * from game_member_sign where uid=$uid and game_code='ylc' and add_time < '".strtotime(date('Y-m-d'))."' and add_time > '".strtotime(date('Y-m-d',time()-(60*60*24)))."' order by add_time desc";
        $signInfo = M("game_member_sign","",$this->__lewan_hezi)->query($sql)[0];

        $signArr = array(
            'sign_day'=>1
            ,'sign_status'=>1
        );
        if(!empty($signInfo) && $signInfo['sign_num'] < 7) {
            $signArr['sign_day'] = $signInfo['sign_num'];
        }

        //判断用户今天是否签到
        // $today = $GLOBALS["conn"]->NumRows($GLOBALS["conn"]->Query("select * from ".get_table("game_member_sign")." where uid=$userid and game_code='hezi' and add_time > '".strtotime(date('Y-m-d'))."'"));
        $signWhere = array(
            'uid'=>$uid
            ,'game_code'=>'ylc'
            ,'add_time'=>array('gt',strtotime(date('Y-m-d')))
        );
        $today = M("game_member_sign","",$this->__lewan_hezi)->where($signWhere)->count();
        if($today > 0) {
            $signArr['sign_status'] = 2;
            if(!empty($signInfo) && $signInfo['sign_num'] < 7) {
                $signArr['sign_day'] = $signInfo['sign_num']+1;
            }
        }

        //获取用户今天做任务数据
        $taskList = C('taskList');
        $taskInfo = array(
            'receive_status'=>0
            ,'receive_num'=>0
            ,'receive_gold'=>0
        );
        $taskWhere = array(
            'uid'=>$uid
            ,'add_time'=>array('gt',date('Y-m-d'))
        );
        $taskArr = M("yl_game_task","",$this->__lewan_hezi)->where($taskWhere)->select();
        if(!empty($taskArr)) {
            foreach($taskArr as $tkey=>$tval) {
                $userReceive = json_decode($tval['receive_info'],true);
                foreach($userReceive as $ukey=>$uval) {
                    if($uval['status'] == 2) {
                        //获取对应任务金币数量
                        foreach($taskList[$tval['type']]['list'] as $key=>$val) {
                            if($val['en_name'] == $ukey) {
                                $gold = $val['gold'];
                            }
                        }
                        $taskInfo['receive_status'] = 1;
                        $taskInfo['receive_num'] += 1;
                        $taskInfo['receive_gold'] += $gold;
                    }
                }
            }
        }

        if(!empty($userInfo)) {
            $result = array(
                'c'=>1
                ,'msg'=>'获取成功'
                ,'d'=>array(
                    'user_info'=>$userInfo
				    ,'sign_info'=>$signArr
				    ,'task_info'=>$taskInfo
                )
            );
        } else {
            $result = array(
                'c'=>2
                ,'msg'=>'用户不存在'
            );
        }
        
        return $result;
    }

    //用户签到
    function userSign($uid,$doubleReward)
    {
        $result = Array();
        $signList = C('signList');
        $signModel = M("game_member_sign","",$this->__lewan_hezi);
        
        // $today = $GLOBALS["conn"]->NumRows($GLOBALS["conn"]->Query("select * from ".get_table("game_member_sign")." where uid=$userid and game_code='hezi' and add_time > '".strtotime(date('Y-m-d'))."'"));
        $signWhere = array(
            'uid'=>$uid
            ,'game_code'=>'ylc'
            ,'add_time'=>array('gt',strtotime(date('Y-m-d')))
        );
        $today = $signModel->where($signWhere)->count();
        if($today > 0) {
            //用户已签到
            $result = array(
                'c'=>2
                ,'msg'=>'用户已签到'
            );
        } else{

            //获取用户签到信息(签到天数验证)
            // $sql = "select * from ".get_table("game_member_sign")." where uid=$userid and game_code='hezi' and add_time < '".strtotime(date('Y-m-d'))."' and add_time > '".strtotime(date('Y-m-d',time()-(60*60*24)))."' order by add_time desc";
            // $result = $GLOBALS["conn"]->Query($sql);
            // $signInfo = $GLOBALS["conn"]->getOne($result);
            $sql = "select * from game_member_sign where uid=$uid and game_code='ylc' and add_time < '".strtotime(date('Y-m-d'))."' and add_time > '".strtotime(date('Y-m-d',time()-(60*60*24)))."' order by add_time desc";
            $signInfo = $signModel->query($sql)[0];
            if(!empty($signInfo) && $signInfo['sign_num'] < 7) {
                $sign_day = $signInfo['sign_num']+1;
            } else {
                $sign_day = 1;
            }

            //进行用户签到记录
            $gold = $signList[$sign_day-1]['gold'];
            if($double_reward == 2) {
                $gold = $gold*2;
            } else {
                $double_reward = 1;
            }

            $signModel->startTrans();
            //记录用户签到
            $signArr = array(
                'uid'=>$uid
                ,'sign_num'=>$sign_day
                ,'double_reward'=>$double_reward
                ,'add_time'=>time()
                ,'add_ip'=>$ip
                ,'game_code'=>'ylc'
            );
            // $re1 = add_record($GLOBALS["conn"],"game_member_sign",$signArr,true);
            $re1 = $signModel->add($signArr);

            //记录用户金币操作
            $goldArr = array(
                'uid'=>$uid
                ,'handle'=>'add'
                ,'gold_num'=>$gold
                ,'add_time'=>date('Y-m-d H:i:s')
                ,'add_ip'=>$ip
                ,'way'=>'sign'
                ,'game_code'=>'ylc'
            );
            // $re2 = add_record($GLOBALS["conn"],"game_member_gold",$goldArr,true);
            $re2 = M("game_member_gold","",$this->__lewan_hezi)->add($goldArr);

            //更新用户金币数量
            $updateArr = array(
                'gold'=>'gold+'.$gold
            );
            $updateWhere = array(
                'uid'=>$uid
            );
            // $re3 = update_record($GLOBALS['conn'],'game_member',$updateArr,$updateWhere);
            $re3 = M("game_member","",$this->__lewan_hezi)->where($updateWhere)->setInc('gold',$gold);

            if($re1 && $re2 && $re3) {
                $signModel->commit();
                $result = array(
                    'c'=>1
                    ,'msg'=>'签到成功'
                );
            } else {
                $result = array(
                    'c'=>2
                    ,'msg'=>'签到失败'
                );
            }
        }
        return $result;
    }


    //用户任务奖励领取
    function taskPrize($uid,$type,$taskName)
    {
        $result = Array();
        $taskList = C('taskList');
        $taskModel = M("yl_game_task","",$this->__lewan_hezi);

		//获取用户今天做任务数据
        $taskWhere = array(
            'uid'=>$uid
            // ,'status'=>2
            ,'add_time'=>array('gt',date('Y-m-d'))
        );
        if(!empty($type)) {
            $taskWhere['type'] = $type;
        }
		$taskArr = $taskModel->where($taskWhere)->select();

		if(!empty($taskArr)) {
            if(!empty($type) && !empty($taskName)) {
                //领取单个任务奖励
                $userReceive = json_decode($taskArr[0]['receive_info'],true);
                if($userReceive[$taskName]['status'] != 2) {
                    $result = array(
                        'c'=>2
                        ,'msg'=>'领取失败'
                    );
                    return $result;
                }

                //获取对应任务金币数量
                foreach($taskList[$type]['list'] as $key=>$val) {
                    if($val['en_name'] == $taskName) {
                        $gold = $val['gold'];
                    }
                }

                $taskModel->startTrans();
                //更新今日任务奖励状态
                $twhere = array(
                    'uid'=>$uid
                    ,'type'=>$type
                    ,'game_code'=>'ylc'
                    ,'add_time'=>array('gt',date('Y-m-d'))
                );
                $userReceive[$taskName]['status'] = 3;
                $re1 = $taskModel->where($twhere)->save(array('receive_info'=>json_encode($userReceive)));
    
                //记录用户金币操作
                $goldArr = array(
                    'uid'=>$uid
                    ,'handle'=>'add'
                    ,'gold_num'=>$gold
                    ,'add_time'=>date('Y-m-d H:i:s')
                    ,'game_code'=>'ylc'
                    ,'way'=>$taskName
                );
                $re2 = M("game_member_gold","",$this->__lewan_hezi)->add($goldArr);
    
                //更新用户金币数量
                $re3 = M("game_member","",$this->__lewan_hezi)->where(array('uid'=>$uid))->setInc('gold',$gold);
    
                if($re1 && $re2 && $re3) {
                    $taskModel->commit();
                    $result = array(
                        'c'=>1
                        ,'msg'=>'领取成功'
                        ,'gold'=>$gold
                    );
                } else {
                    $result = array(
                        'c'=>2
                        ,'msg'=>'领取失败'
                    );
                }

            } else {
                //领取全部任务奖励
                $addgold = 0;
                $judge = false;
                foreach($taskArr as $tkey=>$tval) {
                    $userReceive = json_decode($tval['receive_info'],true);
                    foreach($userReceive as $ukey=>$uval) {
                        if($uval['status'] == 2) {
                            //获取对应任务金币数量
                            foreach($taskList[$tval['type']]['list'] as $key=>$val) {
                                if($val['en_name'] == $ukey) {
                                    $gold = $val['gold'];
                                }
                            }

                            $taskModel->startTrans();
                            //更新今日任务奖励状态
                            $twhere = array(
                                'uid'=>$uid
                                ,'type'=>$tval['type']
                                ,'game_code'=>'ylc'
                                ,'add_time'=>array('gt',date('Y-m-d'))
                            );
                            $userReceive[$ukey]['status'] = 3;
                            $re1 = $taskModel->where($twhere)->save(array('receive_info'=>json_encode($userReceive)));
                
                            //记录用户金币操作
                            $goldArr = array(
                                'uid'=>$uid
                                ,'handle'=>'add'
                                ,'gold_num'=>$gold
                                ,'add_time'=>date('Y-m-d H:i:s')
                                ,'game_code'=>'ylc'
                                ,'way'=>$ukey
                            );
                            $re2 = M("game_member_gold","",$this->__lewan_hezi)->add($goldArr);
                
                            //更新用户金币数量
                            $re3 = M("game_member","",$this->__lewan_hezi)->where(array('uid'=>$uid))->setInc('gold',$gold);

                            if($re1 && $re2 && $re3) {
                                $taskModel->commit();
                                $addgold += $gold;
                                $judge = true;
                            }

                        }
                    }

                }

                if($judge) {
                    $result = array(
                        'c'=>1
                        ,'msg'=>'领取成功'
                        ,'d'=>array(
                            'gold'=>$addgold
                        )
                    );
                } else {
                    $result = array(
                        'c'=>2
                        ,'msg'=>'领取失败'
                    );
                }

            }
 

        }


        return $result;
    }
    
}